﻿Public Class Form1

    ' Plot the equation.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Make the Bitmap.
        Dim bm As New Bitmap(picGraph.ClientSize.Width, picGraph.ClientSize.Height)

        Using gr As Graphics = Graphics.FromImage(bm)
            ' Clear.
            gr.Clear(Color.White)
            gr.ScaleTransform(15.0F, -15.0F, System.Drawing.Drawing2D.MatrixOrder.Append)
            gr.TranslateTransform(bm.Width * 0.5F, bm.Height * 0.5F, _
                System.Drawing.Drawing2D.MatrixOrder.Append)

            ' Draw axes.
            Using axis_pen As New Pen(Color.LightGray, 0)
                gr.DrawLine(axis_pen, -8, 0, 8, 0)
                gr.DrawLine(axis_pen, 0, -8, 0, 8)
                For i As Integer = -8 To 8
                    gr.DrawLine(axis_pen, i, -0.1F, i, 0.1F)
                    gr.DrawLine(axis_pen, -0.1F, i, 0.1F, i)
                Next i
            End Using

            ' Graph the equation.
            Dim dx As Single = 2.0F / bm.Width
            Dim dy As Single = 2.0F / bm.Height
            PlotFunction(gr, -8, -8, 8, 8, dx, dy)
        End Using ' using gr.

        ' Display the result.
        picGraph.Image = bm
    End Sub

    ' Plot a function.
    Private Sub PlotFunction(ByVal gr As Graphics, _
      ByVal xmin As Single, ByVal ymin As Single, ByVal xmax As Single, ByVal ymax As Single, _
      ByVal dx As Single, ByVal dy As Single)

        ' Plot the function.
        Using thin_pen As New Pen(Color.Black, 0)
            ' Horizontal comparisons.
            For x As Single = xmin To xmax Step dx
                Dim last_y As Single = F1(x, ymin)
                For y As Single = ymin + dy To ymax Step dy
                    Dim next_y As Single = F1(x, y)
                    If ( _
                        ((last_y <= 0.0F) AndAlso (next_y >= 0.0F)) OrElse _
                        ((last_y >= 0.0F) AndAlso (next_y <= 0.0F)) _
                       ) _
                    Then
                        ' Plot this point.
                        gr.DrawLine(thin_pen, x, y - dy, x, y)
                    End If
                    last_y = next_y
                Next y
            Next x ' Horizontal comparisons.

            ' Vertical comparisons.
            For y As Single = ymin + dy To ymax Step dy
                Dim last_x As Single = F1(xmin, y)
                For x As Single = xmin + dx To xmax Step dx
                    Dim next_x As Single = F1(x, y)
                    If ( _
                        ((last_x <= 0.0F) AndAlso (next_x >= 0.0F)) OrElse _
                        ((last_x >= 0.0F) AndAlso (next_x <= 0.0F)) _
                       ) _
                    Then
                        ' Plot this point.
                        gr.DrawLine(thin_pen, x - dx, y, x, y)
                    End If
                    last_x = next_x
                Next x
            Next y ' Vertical comparisons.
        End Using ' using thin_pen.
    End Sub

    ' The function.
    ' x3 / (Abs(y) + 1) - 4 * x2 + 4 * x * y2 - y * 6 + 6 = 0
    Private Function F1(ByVal x As Single, ByVal y As Single) As Single
        Return (x * x * x / (Math.Abs(y) + 1) - 4 * x * x + 4 * x * y * y - y * 6 + 6)
    End Function
End Class
